>From 100675cea6eef322ce1dffc3978bffd8222a8361 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Mon, 11 May 2015 02:54:00 +0200
Subject: [PATCH 2/2] WIP-AARR-inlining

---
 src/include/utils/array.h | 28 ++++++++++++++++++++++------
 1 file changed, 22 insertions(+), 6 deletions(-)

diff --git a/src/include/utils/array.h b/src/include/utils/array.h
index d89962c..764ac86 100644
--- a/src/include/utils/array.h
+++ b/src/include/utils/array.h
@@ -307,12 +307,28 @@ typedef struct ArrayIteratorData *ArrayIterator;
 /*
  * Macros for working with AnyArrayType inputs.  Beware multiple references!
  */
-#define AARR_NDIM(a) \
-	(VARATT_IS_EXPANDED_HEADER(a) ? (a)->xpn.ndims : ARR_NDIM(&(a)->flt))
-#define AARR_HASNULL(a) \
-	(VARATT_IS_EXPANDED_HEADER(a) ? \
-	 ((a)->xpn.dvalues != NULL ? (a)->xpn.dnulls != NULL : ARR_HASNULL((a)->xpn.fvalue)) : \
-	 ARR_HASNULL(&(a)->flt))
+static inline int
+AARR_NDIM(AnyArrayType *a)
+{
+	if (VARATT_IS_EXPANDED_HEADER(a))
+		return a->xpn.ndims;
+	else
+		return ARR_NDIM(&(a)->flt);
+}
+
+static inline bool
+AARR_HASNULL(AnyArrayType *a)
+{
+	if (VARATT_IS_EXPANDED_HEADER(a))
+	{
+		if (a->xpn.dvalues != NULL)
+			return a->xpn.dnulls != NULL;
+		else
+			return ARR_HASNULL(a->xpn.fvalue);
+	}
+	else
+		return ARR_HASNULL(&(a)->flt);
+}
 #define AARR_ELEMTYPE(a) \
 	(VARATT_IS_EXPANDED_HEADER(a) ? (a)->xpn.element_type : ARR_ELEMTYPE(&(a)->flt))
 #define AARR_DIMS(a) \
-- 
2.4.0.rc2.1.g3d6bc9a

